# MySQL-Front Dump 2.1
#
# Host: localhost   Database: teaching
#--------------------------------------------------------
# Server version 3.23.39-log


#
# Table structure for table 'answers'
#

CREATE TABLE `answers` (
  `AnswerId` int(10) unsigned NOT NULL auto_increment,
  `QuestionId` int(10) unsigned NOT NULL default '0',
  `Answer` text,
  PRIMARY KEY  (`AnswerId`)
) TYPE=MyISAM;



#
# Table structure for table 'answervariants'
#

CREATE TABLE `answervariants` (
  `QuestionId` int(10) unsigned NOT NULL default '0',
  `VariantNumber` int(10) unsigned NOT NULL default '0',
  `Variant` char(3) NOT NULL default '50',
  PRIMARY KEY  (`QuestionId`,`VariantNumber`),
  UNIQUE KEY `QuestionId` (`QuestionId`,`VariantNumber`)
) TYPE=MyISAM;



#
# Table structure for table 'lessons'
#

CREATE TABLE `lessons` (
  `LessonId` int(10) unsigned NOT NULL auto_increment,
  `LessonName` varchar(50) NOT NULL default '',
  `LessonDescription` text,
  `LessonPath` varchar(50) NOT NULL default '',
  `UserId` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`LessonId`)
) TYPE=MyISAM;



#
# Table structure for table 'questions'
#

CREATE TABLE `questions` (
  `QuestionId` int(10) unsigned NOT NULL auto_increment,
  `TestId` int(10) unsigned NOT NULL default '0',
  `QuestionType` int(10) unsigned NOT NULL default '1',
  `Question` text NOT NULL,
  PRIMARY KEY  (`QuestionId`)
) TYPE=MyISAM;



#
# Table structure for table 'rightanswers'
#

CREATE TABLE `rightanswers` (
  `QuestionId` int(10) unsigned NOT NULL default '0',
  `RightAnswer` int(10) unsigned NOT NULL default '0',
  KEY `QuestionId` (`QuestionId`)
) TYPE=MyISAM;



#
# Table structure for table 'testpassing'
#

CREATE TABLE `testpassing` (
  `PassingId` int(10) unsigned NOT NULL auto_increment,
  `TestId` int(10) unsigned NOT NULL default '0',
  `UserId` int(10) unsigned NOT NULL default '0',
  `Date` datetime default NULL,
  `Mark` int(10) unsigned default NULL,
  PRIMARY KEY  (`PassingId`)
) TYPE=MyISAM;



#
# Table structure for table 'tests'
#

CREATE TABLE `tests` (
  `TestId` int(3) unsigned NOT NULL auto_increment,
  `LessonId` int(3) unsigned NOT NULL default '0',
  `UserId` int(3) unsigned NOT NULL default '0',
  `TestName` varchar(50) default NULL,
  PRIMARY KEY  (`TestId`)
) TYPE=MyISAM;



#
# Table structure for table 'tusers'
#

CREATE TABLE `tusers` (
  `UserId` int(3) unsigned NOT NULL default '0',
  `tuser` char(8) NOT NULL default '',
  `tpass` char(8) NOT NULL default '',
  `tdatetime` datetime NOT NULL default '0000-00-00 00:00:00'
) TYPE=MyISAM;



#
# Table structure for table 'useranswers'
#

CREATE TABLE `useranswers` (
  `QuestionId` int(10) unsigned NOT NULL default '0',
  `Answer` varchar(255) NOT NULL default '0',
  `PassingId` int(10) unsigned NOT NULL default '0',
  KEY `QuestionId` (`QuestionId`)
) TYPE=MyISAM;



#
# Table structure for table 'users'
#

CREATE TABLE `users` (
  `UserId` int(10) unsigned NOT NULL auto_increment,
  `UserName` varchar(50) NOT NULL default '',
  `UserType` int(10) unsigned NOT NULL default '3',
  `UserPass` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`UserId`)
) TYPE=MyISAM;

