#!/usr/bin/perl -w

use CGI qw(:standard *table);
use DBI;
use File::Path;

require 'connect.pl';
require 'print.pl';
require 'datetime.pl';
require 'sec.pl';

my ($dbh, $insertid)=&db_connect();
my $sth;

my $pkunzip = '..\pkunzip.exe';
my $Current_Page = param('state')||'listlesson';
my $ThisFile = 'teacher.cgi';
my $thisfile = url(-relative=>1);
my $DirForLesson = '../Lesson';
my $template = 'template_teach.htm';
my $UserId=0;
 
if ($UserId = param('id'))
{
  $UserId = &SetValues(&GetUserId($dbh,$UserId));
}
$Current_Page='error' if(!$UserId);


my %States 			= (
   		'error'          => \&Error,
   		'addlessonform'  => \&AddLessonForm,
   		'addlesson'      => \&AddLesson,
   		'viewlesson'     => \&ViewLesson,
   		'listlesson'     => \&ListLesson,
   		'dellesson'      => \&DelLesson,
   		'listtest'       => \&ListTest,
   		'listalltest'    => \&ListAllTest,
   		'addtest'        => \&AddTest,
   		'deletetest'     => \&DeleteTest,
   		'addtestform'    => \&AddTestForm,
   		'addquestionform'=> \&AddQuestionForm,
   		'addquestion'    => \&AddQuestion,
   		'addanswer'      => \&AddAnswer,
   		'addanswerform'  => \&AddAnswerForm,
		'setrightanswer' => \&SetRightAnswer,
		'checklist'      => \&CheckList,
		'checkform'      => \&CheckForm,
		'setmark'        => \&SetMark,
		'rating'         => \&Rating
);

while(my($page_name,$function)=each %States){
	if($page_name eq $Current_Page)
    {
	    $function->(); 
    }
}
exit;

sub AddLessonForm
{
 	my $title = ' ';
	my $name_text = ' ';
	my $desc_text = '';
	my $file_text = '';
	my $SubmitValue = '';
	my ($LessonName,$LessonDesc, $LessonId, $change)=();
	if($change=param('change'))
	{
	   $LessonId = param('lessonid');
	   $sth=$dbh->prepare('select LessonName, LessonDescription from lessons where lessonid=? and userid=?');
	   $sth->execute($LessonId, $UserId);
	   ($LessonName,$LessonDesc) = $sth->fetchrow_array();
	}

    &PrintTo("
    <form METHOD=\"POST\"  ENCTYPE=\"multipart/form-data\" action=\"$ThisFile\">
    <input type=hidden name=state value=addlesson>
    <input type=hidden name=change value=$change>
    <input type=hidden name=lessonid value=$LessonId>
	&nbsp;
	<h3 align=center>$title</h3>
	<p align=center>
	<table width='80%'>
    <tr><td align=center>$name_text:</td><td><input type=text name=\"lesname\" value=\"$LessonName\"></td></tr>
    <tr><td align=center>$desc_text:</td><td><textarea name=\"lesdesc\">$LessonDesc</textarea></td></tr>
    <tr><td align=center>$file_text:</td><td><input type=file name=\"ARC\" value=\"Browse\"></td>
    <tr><td colspan=2 align=center><input type=submit value=$SubmitValue></td></tr>
	</table>
	</p>
    </form>
    </body>
    </HTML>
    ");
	&PrintPage($template,$title);
}

sub AddLesson
{
    my $LessonName = param('lesname');
    my $LessonDescription = param('lesdesc');
	my $filename = param('ARC');
	my $LessonId=param('lessonid')||0;
	my $change=param('change');
	if($change)
	{
        $sth = $dbh->prepare('update Lessons set LessonName=?');
		$sth->execute($LessonName);
		$sth->finish();
        $sth = $dbh->prepare('update Lessons set LessonDescription=?');
		$sth->execute($LessonDescription);
		$sth->finish();
		
	}
	else
	{
        $sth = $dbh->prepare('insert into Lessons (LessonName, LessonDescription, UserId) values (?,?,?)');
    	$sth->execute($LessonName, $LessonDescription, $UserId);
    	$LessonId = $sth->{$insertid};
    	$sth->finish();
	}
	if($filename)
	{
     	my $dirname = $DirForLesson . $LessonId;
	    rmtree $DirForLesson . $LessonId;
        mkpath $dirname;
    	$dirname .= '/';
    
        $filename =~ s/.*\\(.*)$/$1/;
		if($filename ne '')
		{
            my $Arc = &UploadFile();
            open  ARC,'>' . $dirname . $filename or die 'Error openning file!!!' .$filename;
            binmode ARC;
            print ARC $Arc;
            close ARC;
        	&UnPackFile($filename,$dirname);
		}
	}
    print redirect(-uri=>"$ThisFile?state=listlesson&".&GetiRef());
}

sub DelLesson
{
  	my $LessonId = param('lessonid');
	rmtree $DirForLesson . $LessonId;
	$sth = $dbh->prepare('DELETE FROM lessons WHERE LessonId=?');
	$sth->execute($LessonId);
	$sth->finish();
    print redirect(-uri=>"$ThisFile?state=listlesson&".&GetiRef());
}

sub ListLesson
{
    my $title = '';
	my $id_text = "";
	my $name_text = "";
	my $delete_text = "";
	my $add_text = ' ';
    my ($LessonId, $LessonName, $i)=();

	&PrintTo('<P align=CENTER>');
	&PrintTo(start_table({-width=>'80%'}));
	&PrintTo(th([$id_text,$name_text,$delete_text]));
    $sth = $dbh->prepare('SELECT LessonId, LessonName FROM Lessons where userid=? ORDER BY LessonId ');
	$sth->execute($UserId);
	for($i=1;(($LessonId, $LessonName) = $sth->fetchrow_array());$i++)
	{
	  &PrintTo(Tr({-align=>RIGHT},
	                  td({align=>'center'},
					    [ 
						  $i, 
						  a({-href=>$ThisFile . '?state=listtest&lessonid=' . $LessonId.$tuserpass},$LessonName),
						  a({-href=>$ThisFile . '?state=dellesson&lessonid=' . $LessonId.$tuserpass},$delete_text)
						])
					  ));
	}
	&PrintTo(Tr(td({-colspan=>3,-align=>'center'},[a({-href=>$ThisFile.'?state=addlessonform'.$tuserpass},$add_text)])));
	&PrintTo(end_table());
	&PrintTo("</P>");
	&PrintPage($template,$title);
}

sub ListTest
{
  my ($TestId,$TestName);
  my $lesson_text = '';
  my $theory_text = '';
  my $change_text = '';
  my $tests_text  = '   ';
  my $delete_text = ' ';
  my $add_text = ' ';
    
  my $LessonId=param('lessonid');
  my $title = $lesson_text;
  &PrintTo("&nbsp;<p align=center><table width='80%'>");
  &PrintTo("<tr><td><a href=$ThisFile?state=viewlesson&lessonid=$LessonId>" . 
           "$theory_text</a></td><td><a href=$ThisFile?state=addlessonform&".
		   "lessonid=$LessonId&change=1>$change_text</a></td></tr>");
  &PrintTo("<tr><td colspan=2><h3 align=center>$tests_text</h3></td></tr>");

  $sth = $dbh->prepare('SELECT TestId, TestName FROM Tests where lessonid=? ORDER BY TestId ');
  $sth->execute($LessonId);
  while(($TestId, $TestName) = $sth->fetchrow_array())
  {
    &PrintTo("<tr><td><a href=\"$ThisFile?state=addtestform&lessonid=$LessonId&testid=$TestId&change=1\">$TestName</a></td><td><a href=$ThisFile?state=deletetest&testid=$TestId&lessonid=$LessonId>$delete_text</a></td></tr>");
  }
  $sth->finish();
  &PrintTo("<tr><td colspan=2 align=center><a href=$ThisFile?state=addtestform&lessonid=$LessonId>$add_text</a></td></tr>");
  &PrintTo("</table></p>");
  &PrintPage($template,$title);
}

sub ListAllTest
{
  my ($TestId,$TestName);
  my $change_text = '';
  my $tests_text  = ' ';
  my $delete_text = ' ';
    
  my $title = $tests_text;
  &PrintTo("<p align=center><table width='80%'><tr><td colspan=2><h3 align=center>$tests_text</h3></td></tr>");

  $sth = $dbh->prepare('SELECT TestId, TestName FROM Tests WHERE userid=? ORDER BY TestId ');
  $sth->execute($UserId);
  while(($TestId, $TestName) = $sth->fetchrow_array())
  {
    &PrintTo("<tr><td><a href=\"$ThisFile?state=addtestform&lessonid=$LessonId&testid=$TestId&change=1\">$TestName</a></td><td><a href=$ThisFile?state=deletetest&testid=$TestId&lessonid=$LessonId>$delete_text</a></td></tr>");
  }
  $sth->finish();
  &PrintTo("</table></p>");
  &PrintPage($template,$title);
}


sub AddTestForm
{
  my $LessonId = param('lessonid');
  my $Change = param('change');
  my $addquest_text = ' ';
  my $name_text = '';
  my $add_text = '';
  my $change_text = '';
  my $addtest_text = ' ';
  my $changetest_text = ' ';
  
  my $title;
  my ($TestName, $TestId)='';
  if($Change)
  {
    $TestId = param('testid');
    $sth = $dbh->prepare("SELECT TestName FROM Tests WHERE TestId=?");
	$sth->execute($TestId);
    $TestName = $sth->fetchrow_array();
	$sth->finish(); 
    $SubmitValue = $change_text;
	$title = $changetest_text; 
  }
  else
  {
	$title = $addtest_text; 
    $SubmitValue = $add_text; 
  }
  &PrintTo("<form method=get action=$ThisFile>");
  &PrintTo("<input type=hidden name=state value=addtest>");
  &PrintTo("<input type=hidden name=lessonid value=$LessonId>");
  &PrintTo("<input type=hidden name=change value=$Change>");
  &PrintTo("<input type=hidden name=testid value=$TestId>");
  &PrintTo("<p align=center>&nbsp;");
  &PrintTo("<table width='80%'>");
  &PrintTo("<tr><td >$name_text:</td><td><input type=text name=testname value =\"$TestName\"></td>");
  &PrintTo("<td colspan=2 align=center><input type=submit value=$SubmitValue></td></tr>");
  if($TestId)
  {
    &PrintTo("<tr><td colspan=3 align=center></td></tr>");
    $sth = $dbh->prepare("SELECT QuestionId, Question, QuestionType FROM Questions WHERE TestId=?");
	$sth->execute($TestId);
    while(($QuestionId,$Question, $QuestionType) = $sth->fetchrow_array())
    { 
      &PrintTo("<tr><td colspan=3 align=center><a href=$ThisFile?state=addquestionform&testid=$TestId&questionid=$QuestionId&change=1>$Question</a></td></tr>");
    }
    &PrintTo("<tr><td colspan=3 align=center><a href=$ThisFile?state=addquestionform&testid=$TestId>$addquest_text</a></td></tr>");
  }
  &PrintTo("</table>");
  &PrintTo("</p>");
  &PrintTo("</form>");
  &PrintPage($template,$title);
}

sub AddQuestionForm
{
  my $TestId = param('testid');
  my $Change = param('change');
  my ($QuestionId, $Question)='';
  my @Checked='';
  my ($AnswerId, $Answer, $RightAnswer, $ch);

  my $addquest_text = ' ';
  my $changequest_text = ' ';
  my $addans_text = ' ';
  my $add_text = '';
  my $change_text = '';
  my $button_text = '';
  my $saveright_text = '  ';
  
  my $title;
  
  if($Change)
  {
    $QuestionId = param('questionid');
    $sth = $dbh->prepare("SELECT Question, QuestionType FROM Questions WHERE QuestionId=?");
	$sth->execute($QuestionId);
    ($Question, $QuestionType) = $sth->fetchrow_array();
	$sth->finish();
	$Checked[$QuestionType]='CHECKED';
	$title = $changequest_text;
    $SubmitValue = $change_text;
  }
  else
  {
	$title = $addquest_text;
    $SubmitValue = $add_text;
  }
  &PrintTo( "<form method=post action=$ThisFile>");
  &PrintTo( "<input type=hidden name=state value=addquestion>");
  &PrintTo( "<input type=hidden name=testid value=$TestId>");
  &PrintTo( "<input type=hidden name=change value=$Change>");
  &PrintTo( "<input type=hidden name=questionid value=$QuestionId>");
  &PrintTo( "&nbsp;<p align=center><table width='80%'>");
  &PrintTo( "<tr><td>:</td><td><textarea name=question>$Question</textarea></td></tr>");
  &PrintTo( "<tr><td> :</td><td>1.<input type=radio name=questiontype value=1 $Checked[1]><input type=radio checked></td></tr>" .
                   "<tr><td></td><td>2.<input type=radio name=questiontype value=2 $Checked[2]><input type=checkbox checked></td></tr>" .
#				   "<tr><td></td><td>3.<input type=radio name=questiontype value=3 $Checked[3]><input type=button value=$button_text></td></tr>" .
				   "<tr><td></td><td>3.<input type=radio name=questiontype value=4 $Checked[4]><textarea></textarea></td></tr>");
  &PrintTo( "<tr><td></td><td><input type=submit value=$SubmitValue></td></tr>");
  &PrintTo( "</form>");

  if($QuestionId and $QuestionType!=4)
  {
    $sth = $dbh->prepare("SELECT rightanswer FROM rightanswers WHERE QuestionId=?");
	$sth->execute($QuestionId);
    ($RightAnswer) = $sth->fetchrow_array();

    &PrintTo( "<tr><td></td><td><table><form name=form1 method=get action=$thisfile><tr><td></td><td>:</td></tr>");
    &PrintTo( "<input type=hidden name=state value=setrightanswer>");
    &PrintTo( "<input type=hidden name=questionid value=$QuestionId>");
    $sth = $dbh->prepare("SELECT AnswerId, Answer FROM Answers WHERE QuestionId=?");
	$sth->execute($QuestionId);
    for ($i=1;($AnswerId, $Answer) = $sth->fetchrow_array(); $i++)
    {
	  $ch='checked' if ($RightAnswer & Power(2,$i)); 
   	  &PrintTo( "<tr><td></td><td>");
	  &PrintTo( "<input type=radio name=answer value=$i $ch>") if $QuestionType==1;
	  &PrintTo( "<input type=checkbox name=answer value=$i $ch>") if $QuestionType==2;
	  if ($QuestionType==3) 
	  {
	    &PrintTo( "<input type=radio name=answer value=$i $ch><input type=button onClick=\"document.URL='$thisfile?state=addanswerform&questionid=$QuestionId&answerid=$AnswerId&change=1$tuserpass'\" value=\"$Answer\" name=answer${i}>");
	  }
	  else
	  {
  	    &PrintTo( "<a href=$thisfile?state=addanswerform&questionid=$QuestionId&answerid=$AnswerId&change=1$tuserpass>$Answer</a>");
	  }
	  &PrintTo( "</td></tr>");
	  $ch='';
    }
	  &PrintTo( "<tr><td></td><td><input type=submit value='$saveright_text'></td></tr></form></table></td></tr>");
    &PrintTo( "<tr><td></td><td><a href=$ThisFile?state=addanswerform&questionid=$QuestionId>$addans_text</a></td></tr>");
  }
  &PrintTo("</table>");
  &PrintPage($template,$title);
}

sub AddQuestion
{
  my $TestId = param('testid');
  my $Question = param('question');
  my $QuestionType = param('questiontype');
  my $QuestionId;
  if(!param('change'))
  {
    $sth = $dbh->prepare("INSERT INTO QUESTIONS (TestId, QuestionType, Question) ".
                                  "VALUES(?,?,?)");
	$sth->execute($TestId,$QuestionType,$Question);
    $QuestionId = $sth->{$insertid};
	$sth->finish();
  }
  else
  {
    $QuestionId = param('questionid');
    $sth = $dbh->prepare("UPDATE QUESTIONS SET Question=? ".
                                  "WHERE QuestionId=?");
	$sth->execute($Question,$QuestionId);
    $sth = $dbh->prepare("UPDATE QUESTIONS SET QuestionType=? ".
                                  "WHERE QuestionId=?");
	$sth->execute($QuestionType,$QuestionId);
	$sth->finish();
  }
  print redirect(-uri=>"$ThisFile?state=addquestionform&testid=$TestId&questionid=$QuestionId&change=1&".&GetiRef());
}

sub AddTest
{
  my $LessonId = param('lessonid');
  my $TestName = param('testname');
  my $TestId;

  if(!param('change'))
  {
    $sth = $dbh->prepare("INSERT INTO TESTS ( LessonId, UserId, TestName) ".
                                  "VALUES(?,?,?)");
	$sth->execute($LessonId,$UserId,$TestName);
    $TestId = $sth->{$insertid};
  }
  else
  {
    $TestId = param('testid');
    $sth = $dbh->prepare("UPDATE TESTS SET TestName=? ".
                                  "WHERE TestId=?");
	$sth->execute($TestName, $TestId);
	$sth->finish();
  }
  print redirect(-uri=>"$ThisFile?state=addtestform&lessonid=$LessonId&testid=$TestId&change=1&".&GetiRef()) ;
}

sub DeleteTest()
{
  my $title = ' ';
  &PrintTo('  ');
  &PrintPage($template,$title);
}

sub AddAnswer()
{
  my $QuestionId = param('questionid');
  my $Answer = param('answer');
  my $AnswerId;
  if(!param('change'))
  {
    $sth = $dbh->prepare("INSERT INTO ANSWERS (AnswerId, QuestionId, Answer) ".
                                  "VALUES(?,?,?)");
	$sth->execute($AnswerId,$QuestionId,$Answer);
    $AnswerId = $sth->{$insertid};
	$sth->finish();
  }
  else
  {
    $AnswerId = param('answerid');
    $sth = $dbh->prepare("UPDATE ANSWERS SET Answer=? ".
                                  "WHERE AnswerId=?");
	$sth->execute($Answer,$AnswerId);
	$sth->finish();
  }
  print redirect(-uri=>"$ThisFile?state=addquestionform&questionid=$QuestionId&change=1&".&GetiRef());
}

sub AddAnswerForm()
{
  my $QuestionId = param('questionid');
  my $Change = param('change');
  my ($AnswerId, $Answer)='';
  my $addans_text = ' ';
  my $changeans_text = ' ';
  my $answer_text = '';
  my $SubmitValue;
  my $title;

  if($Change)
  {
    $AnswerId = param('answerid');
    $sth = $dbh->Query("SELECT Answer FROM Answers WHERE AnswerId=\"$AnswerId\"");
    ($Answer) = $sth->FetchRow;
	$SubmitValue = $changeans_text;
	$title = $changeans_text;
  }
  else
  {
	$SubmitValue = $addans_text;
	$title = $addans_text;
  }
  &PrintTo( "<form method=post action=$ThisFile>");
  &PrintTo( "<input type=hidden name=state value=addanswer>");
  &PrintTo( "<input type=hidden name=questionid value=$QuestionId>");
  &PrintTo( "<input type=hidden name=change value=$Change>");
  &PrintTo( "<input type=hidden name=answerid value=$AnswerId>");
  &PrintTo( "<p align=center>&nbsp;");
  &PrintTo( "<table width='80%'>");
  &PrintTo( "<tr><td>$answer_text:</td><td><textarea name=answer>$Answer</textarea></td>");
  &PrintTo( "<td><input type=submit value=$SubmitValue></td></tr>");

  &PrintTo( "</table></p>");
  &PrintTo( "</form>");
  &PrintPage($template,$title);
}

sub UploadFile
{
    my $Result;
    my $paramname = 'ARC';
    if(my $file = param($paramname))
	{ 
     	while (my $bytesread = read($file, my $buffer, 1024))
    	{ 
        	$Result .= $buffer;
   	    }
	}
    return $Result;
}

sub UnPackFile
{
  my $dirname = $_[1];            # Directory;
  my $arcname = $dirname . $_[0]; # Filename
  my $dname = $dirname;
  $dname =~ s/\//\\/g;
  print '>' . $dname . '1.txt';
  my @LIST = ($arcname, $dirname,'-d', '-o', '>' . $dname . '1.txt');
  system $pkunzip, @LIST;
  return;
}

sub SetRightAnswer()
{
  my $QuestionId = param('questionid');
  my @arr = param('answer');
  my $ranswer=0;
  my $i;
  for ($i=0;$i<@arr;$i++){$ranswer += Power(2,$arr[$i]) ;}
  $sth = $dbh->prepare("DELETE FROM rightanswers WHERE questionid=?");
  $sth->execute($QuestionId);
  $sth->finish();
  $sth = $dbh->prepare("INSERT INTO rightanswers (questionid,rightanswer) values(?,?)");
  $sth->execute($QuestionId,$ranswer);
  $sth->finish();
  print redirect(-uri=>"$ThisFile?state=addquestionform&questionid=$QuestionId&change=1&".&GetiRef);
}


sub ViewLesson 
{
  my $LessonId = param('lessonid');
  my $title = '';
  
  open FILE, $DirForLesson . $LessonId . '/index.htm' or die "Error opening file index.htm";
  @F = <FILE>;
  for ($i=0; $i<@F;$i++)
  {
     $F[$i]=~s/background="/background="${DirForLesson}${LessonId}\//gi;
     $F[$i]=~s/src="/src="${DirForLesson}${LessonId}\//gi;
     $F[$i]=~s/href="/href="${DirForLesson}${LessonId}\//gi;
  }
  close FILE;
  for($i=0;($i<@F-1 and not $F[$i]=~m/<body/i);$i++){;}; 
  for($k=$i+1;($k<@F-1 and not $F[$k-1]=~m/<\body/i);$k++){&PrintTo($F[$k])}; 
  &PrintPage($template,$title);
}

sub CheckList()
{
    my $title = ' ';
	my ($LessonName,$TestName,$TestDate,$TestMark);
	my $lesson_name_text = ' ';
	my $test_name_text = ' ';
	my $test_date_text = ' ';
	my $test_mark_text = '';
	my $not_checked_text = '';

	&PrintTo("<p align='center'>");
	&PrintTo(start_table({-width=>'80%'}));
	&PrintTo(Tr(th[$lesson_name_text,$test_name_text,$test_date_text,$test_mark_text]));
	$sth=$dbh->prepare("select l.lessonname, t.testname, tp.date, tp.mark, tp.passingid from testpassing as tp, lessons as l, tests as t where l.userid=? and t.lessonid=l.lessonid and t.testid=tp.testid");
	$sth->execute($UserId);
	while(($LessonName,$TestName,$TestDate,$TestMark,$PassingId)=$sth->fetchrow_array())
	{ 
	  &PrintTo(Tr(td({-align=>'center'},[$LessonName,$TestName,$TestDate,$TestMark||"<a href=$ThisFile?state=checkform&passingid=$PassingId>$not_checked_text</a>"])));
	}
	&PrintTo(end_table());
	&PrintTo("</p>");
    &PrintPage($template,$title);
}

sub CheckForm()
{
    my $title       = ' ';
	my $submit_text = '';
	my $Mark_text   = '';
	my $PassingId   = param('passingid');
	my ($TestId, $TestName);
	my @Answers =();
    my $result;
	my @RAnswers=();

    $sth = $dbh->prepare("SELECT t.TestName, t.TestId FROM Tests as t, ".
		      "TestPassing as tp WHERE t.TestId=tp.TestId and tp.PassingId=?");
	$sth->execute($PassingId);
    ($TestName, $TestId) = $sth->fetchrow_array();
	$sth->finish();
	
    $sth = $dbh->prepare("SELECT ua.Answer, ra.RightAnswer FROM ".
		                 "UserAnswers as ua,RightAnswers as ra WHERE ra.QuestionId=ua.QuestionId and PassingId=? order by ua.QuestionId");
	$sth->execute($PassingId);
    for($i=1;($Answers[$i],$RAnswers[$i])=$sth->fetchrow_array();$i++){;}
	$sth->finish();

	&PrintTo(br,br,h3({-align=>'CENTER'},$TestName));
    &PrintTo('<P align=CENTER>');
    &PrintTo(start_table({-width=>'80%'}));
    $sth = $dbh->prepare("SELECT QuestionId, Question, QuestionType FROM Questions WHERE TestId=?");
	$sth->execute($TestId);
    for($j=1;($QuestionId,$Question, $QuestionType) = $sth->fetchrow_array();$j++)
    {
	  if($Answers[$j]==$RAnswers[$j]){$result='+';}else{$result='-';} 
      &PrintTo(Tr(td([$j.'.',$Question,h1($result)])));
	  &PrintTo(hidden({-name=>'qid'.$j,-value=>$QuestionId}));
      my $sth1 = $dbh->prepare("SELECT AnswerId, Answer FROM Answers WHERE QuestionId=?");
      if ($QuestionType==4)
	  { 
	    ($AnswerId,$Answer) = $sth1->fetchrow_array(); 
		&PrintTo(Tr(td(['',textarea({-value=>"$Answer",-name=>'quest'.$QuestionId,-rows=>'10',-columns=>'50'}),''])));
	  }
	  else
	  {
	    $sth1->execute($QuestionId);
        for($i=1;($AnswerId,$Answer) = $sth1->fetchrow_array();$i++)
	    {
		  if ($Answers[$j]&Power(2,$i)){$checked='checked';}else{$checked='';}
	      &PrintTo("<tr><td></td><td>");
	      &PrintTo("<input type=radio name=quest$QuestionId value=$i $checked>$Answer")    if $QuestionType==1;
	      &PrintTo("<input type=checkbox name=quest$QuestionId value=$i $checked>$Answer") if $QuestionType==2;
#        &PrintTo("<input type=button onClick=\"document.URL='$thisfile?state=addanswerform&questionid=$QuestionId&answerid=$AnswerId&change=1$tuserpass'\" value=\"$Answer\" name=answer${i}>")if($QuestionType==3);
	      &PrintTo("</td><td></td></tr>");
	    }
	    $sth1->finish();
	  }
    }
    $sth->finish();
	&PrintTo(end_table());
	&PrintTo(startform({-action=>$ThisFile}));
    &PrintTo(start_table({-width=>'80%'}));
	&PrintTo("<input type='hidden' name='state' value='setmark'>");
	&PrintTo("<input type='hidden' name='passingid' value=$PassingId>");
	&PrintTo(Tr(td([$Mark_text.':',"<input type='text' name='mark'>"])));
	&PrintTo(Tr(td({-colspan=>2},[submit({-value=>$submit_text})])));
	&PrintTo(end_table());
    &PrintTo('</P>');
	&PrintTo(endform());
    &PrintPage($template,$title);
}

sub SetMark()
{
    my $Mark = param('mark');
    my $PassingId = param('passingid');
    $sth = $dbh->prepare("UPDATE TestPassing set Mark=? where PassingId=?");
	$sth->execute($Mark,$PassingId);
	$sth->finish();
    print redirect(-uri=>"$ThisFile?state=checklist&".&GetiRef);
}

sub Power
{
  my $i;
  my $res = 1;
  for ($i=0; $i<$_[1];$i++){$res*=$_[0];}
  return $res;
}

sub Rating()
{
  my $title = ' ';
  my $Rating_text = '';
  my $Name_text = '';
  &PrintTo("<p align='center'>");
  &PrintTo(start_table({-width=>'80%'}));
  &PrintTo(Tr(td([br,br,''])));
  
  &PrintTo(Tr(th([$Name_text, $Rating_text])));
  my $sth = $dbh->prepare("SELECT COUNT(*), SUM(tp.mark), u.UserName FROM TestPassing as tp, Tests as t, Users as u where t.TestId=tp.TestId and t.UserId=? and mark is not null and tp.UserId=u.UserId group by tp.UserId"); 
  $sth->execute($UserId);
  while(my ($Count, $Sum, $uname) = $sth->fetchrow_array())
  {
    my $Rating = $Sum/$Count;
    &PrintTo(Tr(td({align=>'center'},[$uname ,$Rating])));
  }
  
  &PrintTo(end_table());
  &PrintTo("</p>");
  &PrintPage($template,$title); 
}