#!/usr/bin/perl

use CGI qw(:standard *table);
use DBI;
require 'connect.pl';
require 'print.pl';
require 'datetime.pl';
require 'sec.pl';

my ($dbh, $insertid)=&db_connect();
my $sth;

my $template = 'template_user.htm';
my $DirForLesson = '../Lesson';

my $Current_Page = param('state')||'listlessons';
my $ThisFile = url(-relative=>1);

my $UserId=0;
 
if ($UserId = param('id'))
{
  $UserId = &SetValues(&GetUserId($dbh,$UserId));
}
$Current_Page='error' if(!$UserId);

my %States 			= (
   		'error'          => \&Error,
   		'listlessons'    => \&ListLessons,
   		'listtest'       => \&ListTest,
   		'listalltest'    => \&ListAllTest,
   		'viewlesson'     => \&ViewLesson,
   		'test'           => \&Test,
		'setanswers'     => \&SetAnswers,
		'results'        => \&Results,
		'rating'        => \&Rating
);

while(my($page_name,$function)=each %States){
	if($page_name eq $Current_Page)
    {
	    $function->(); 
    }
}
exit;

sub ListLessons
{
    my ($LessonId, $LessonName);
	my $title_text       = '';
    my $lesson_name_text = ' ';
	my $teacher_text     = '';
	my $description_text = '';
	
	my $k=1;
	my ($LessonId, $LessonName, $LessonDescription, $TeacherName)=();

	&PrintTo('<P align=CENTER>');
	&PrintTo(start_table({-width=>'80%'}));
	&PrintTo(th(['', $lesson_name_text,$teacher_text, $description_text]));

    $sth = $dbh->prepare('SELECT LessonId, LessonName, LessonDescription, UserName FROM Lessons, Users where Users.UserId=Lessons.UserId ORDER BY LessonId');
	$sth->execute();

	while(($LessonId, $LessonName, $LessonDescription, $TeacherName) = $sth->fetchrow_array())
	{
	  &PrintTo(Tr({-align=>CENTER, -style => 'font-family:Times; font-size:14pt'},
	                  td(
					    [ 
						  $k++ . '.',
						  a({-href=>$ThisFile . '?state=listtest&lessonid=' . $LessonId.$tuserpass},$LessonName),
						  $TeacherName,
						  $LessonDescription
						])
					  ));
	}
	&PrintTo(end_table());
	&PrintTo('</P>');
    &PrintPage($template,$title_text); 
}

sub ListTest
{
  my ($TestId,$TestName);
  my $LessonId=param('lessonid');
  my $title = '';
  
  &PrintTo('<P align=CENTER>');
  &PrintTo(start_table(-width=>'80%'));
  &PrintTo(Tr({-align=>CENTER},
                 td({-colspan=>'2'},
                 [
				   a({-href=>"$ThisFile?state=viewlesson&lessonid=$LessonId"}, ''),
				 ]
				 )
			 ));
  &PrintTo(Tr(td({-colspan=>'2'},[' '])));

  $sth = $dbh->prepare('SELECT TestId, TestName FROM Tests where lessonid=? ORDER BY TestId');
  $sth->execute($LessonId);
  while(($TestId, $TestName) = $sth->fetchrow_array())
  {
    &PrintTo(Tr({-align=>CENTER},td([
				   a({-href=>"$ThisFile?state=test&lessonid=$LessonId&testid=$TestId"}, $TestName),
	             ])));
  }
  &PrintTo(end_table());
  &PrintTo('</P>');
  &PrintPage($template,$title); 
}

sub ListAllTest
{
  my ($TestId,$TestName);
  my $LessonId=param('lessonid');
  my $title = '';
  my $TestList = ' ';
  
  &PrintTo('<P align=CENTER>');
  &PrintTo(start_table(-width=>'80%'));
  &PrintTo(Tr(td({-colspan=>'2'},[h3($TestList)])));

  $sth = $dbh->prepare('SELECT TestId, TestName FROM Tests ORDER BY TestId');
  $sth->execute();
  while(($TestId, $TestName) = $sth->fetchrow_array())
  {
    &PrintTo(Tr({-align=>CENTER},td([
				   a({-href=>"$ThisFile?state=test&lessonid=$LessonId&testid=$TestId"}, $TestName),
	             ])));
  }
  &PrintTo(end_table());
  &PrintTo('</P>');
  &PrintPage($template,$title); 
}


sub Test
{
    my $title = '';
	my $submit_text = '';
	my $TestId = param('testid');

	&PrintTo(startform({-action=>$ThisFile}));
	&PrintTo("<input type='hidden' name='state' value='setanswers'>");
	&PrintTo("<input type='hidden' name='testid' value=$TestId>");
    $sth = $dbh->prepare("SELECT TestName FROM Tests WHERE TestId=?");
	$sth->execute($TestId);
    $TestName = $sth->fetchrow_array();
	$sth->finish();
	
	&PrintTo(br,br,h3({-align=>CENTER},$TestName));
    &PrintTo('<P align=CENTER>');
    &PrintTo(start_table({-width=>'80%'}));
    $sth = $dbh->prepare("SELECT QuestionId, Question, QuestionType FROM Questions WHERE TestId=?");
	$sth->execute($TestId);
    for($j=1;($QuestionId,$Question, $QuestionType) = $sth->fetchrow_array();$j++)
    { 
      &PrintTo(Tr(td([$j.'.',$Question])));
	  &PrintTo(hidden({-name=>'qid'.$j,-value=>$QuestionId}));
      my $sth1 = $dbh->prepare("SELECT AnswerId, Answer FROM Answers WHERE QuestionId=?");
      if ($QuestionType==4)
	  {  
		&PrintTo(Tr(td(['',textarea({-name=>'quest'.$QuestionId,-rows=>'10',-columns=>'50'})])));
	  }
	  else
	  {
	    $sth1->execute($QuestionId);
        for($i=1;($AnsweId,$Answer) = $sth1->fetchrow_array();$i++)
	    {
	      &PrintTo("<tr><td></td><td>");
	      &PrintTo("<input type=radio name=quest$QuestionId value=$i>$Answer")    if $QuestionType==1;
	      &PrintTo("<input type=checkbox name=quest$QuestionId value=$i>$Answer") if $QuestionType==2;
#        &PrintTo("<input type=button onClick=\"document.URL='$thisfile?state=addanswerform&questionid=$QuestionId&answerid=$AnswerId&change=1$tuserpass'\" value=\"$Answer\" name=answer${i}>")if($QuestionType==3);
	      &PrintTo("</td></tr>");
	    }
	    $sth1->finish();
	  }
    }
    $sth->finish();
	&PrintTo(Tr(td({-colspan=>2},submit({-value=>$submit_text}))));
	&PrintTo(end_table());
    &PrintTo('</P>');
	&PrintTo(endform());
    &PrintPage($template,$title); 
}

sub SetAnswers()
{
  my $TestId = param('testid')||'0';
  $sth = $dbh->prepare("INSERT INTO testpassing (TestId, UserId, Date) VALUES(?,?,?)");
  $sth->execute($TestId,$UserId,&getdatetime());
  my $PassingId = $sth->{$insertid};
  my $sth1 = $dbh->prepare("SELECT questiontype FROM questions where questionid=?"); 
  $sth = $dbh->prepare("INSERT INTO useranswers (questionid,answer, passingid) values(?,?,?)");
  for($i=1;$QuestionId=param('qid'.$i);$i++)
  {
    $sth1->execute($QuestionId);
	my $QuestionType = $sth1->fetchrow_array();
    my $answer = 0;
	if ($QuestionType != 4)
	{
        my @arr = param('quest' . $QuestionId);
        for ($j=0;$j<@arr;$j++){$answer += Power(2,$arr[$j]) ;}
	}
	else
	{
        $answer = param('quest' . $QuestionId);
	}
	$sth->execute($QuestionId,$answer,$PassingId);
  }
  print redirect(-uri=>"$ThisFile?state=results&".&GetiRef());
}

sub Power
{
  my $i;
  my $res = 1;
  for ($i=0; $i<$_[1];$i++){$res*=$_[0];}
  return $res;
}

sub Results
{
    my $title = '';
	my $lesson_name_text = ' ';
	my $test_name_text = ' ';
	my $test_date_text = ' ';
	my $test_mark_text = '';
	my $not_checked_text = ' ';
    
	my ($LessonName,$TestName,$TestDate,$TestMark);
	&PrintTo("<p align='center'>");
	&PrintTo(start_table({-width=>'80%'}));
	&PrintTo(Tr(th[$lesson_name_text,$test_name_text,$test_date_text,$test_mark_text]));
	$sth=$dbh->prepare("select l.lessonname, t.testname, tp.date, tp.mark from testpassing as tp, lessons as l, tests as t where tp.userid=? and t.lessonid=l.lessonid and t.testid=tp.testid");
	$sth->execute($UserId);
	while(($LessonName,$TestName,$TestDate,$TestMark)=$sth->fetchrow_array())
	{ 
	  &PrintTo(Tr(td({-align=>center},[$LessonName,$TestName,$TestDate,$TestMark||$not_checked_text])));
	}
	&PrintTo(end_table());
	&PrintTo("</p>");
    &PrintPage($template,$title); 
}

sub ViewLesson 
{
  my $LessonId = param('lessonid');
  my $title = '';
  
  open FILE, $DirForLesson . $LessonId . '/index.htm' or die "Error opening file index.htm";
  @F = <FILE>;
  for ($i=0; $i<@F;$i++)
  {
     $F[$i]=~s/background="/background="${DirForLesson}${LessonId}\//gi;
     $F[$i]=~s/src="/src="${DirForLesson}${LessonId}\//gi;
     $F[$i]=~s/href="/href="${DirForLesson}${LessonId}\//gi;
  }
  close FILE;
  for($i=0;($i<@F-1 and not $F[$i]=~m/<body/i);$i++){;}; 
  for($k=$i+1;($k<@F-1 and not $F[$k]=~m/<\body/i);$k++){&PrintTo($F[$k])}; 
  &PrintPage($template,$title); 
}

sub Rating()
{
  my $title = '';
  my $Rating_text = ' ';
  &PrintTo("<p align='center'>");
  &PrintTo(start_table({-width=>'80%'}));
  &PrintTo(Tr(td([br,br,''])));
  
  my $sth = $dbh->prepare("SELECT COUNT(*), SUM(mark) FROM TestPassing where UserId=? and mark is not null"); 
  $sth->execute($UserId);
  my ($Count, $Sum) = $sth->fetchrow_array();
  my $Rating = $Sum/$Count;
   
  &PrintTo(Tr(td([$Rating_text . ':',$Rating])));
  
  &PrintTo(end_table());
  &PrintTo("</p>");
  &PrintPage($template,$title); 
}